//
//  AppSDKManager.h
//  blaccount_flutter_plugin
//
//  Created by 王振 on 2021/8/24.
//

#import <Foundation/Foundation.h>

typedef void(^successIdWithBlock)(id _Nullable param);
typedef void(^failureIdWithBlock)(id _Nonnull param);

NS_ASSUME_NONNULL_BEGIN

@interface AppSDKManager : NSObject


+ (instancetype)sharedManager;


-(BOOL)blAppSDKAccountInit;
//账号密码登录
-(void)loginWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//本地密码登录
-(void)localLoginWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//验证码登录
-(void)fastLoginWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送验证码登录的验证码
-(void)sendFastVCodeForLoginWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送手机号注册验证码
-(void)sendPhoneCodeForRegisterWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送邮箱注册验证码
-(void)sendEmailCodeForRegisterWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//注册
-(void)registerAccountWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//重置密码发送验证码
-(void)resetPwdSendVCodeWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//重置密码
-(void)resetPwdWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送修改手机号的验证码，
-(void)sendVCodeToModifyPhoneWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送修改邮箱的验证码
-(void)sendVCodeToModifyEmailWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure ;
//修改手机号
-(void)modifyPhoneWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//修改邮箱
-(void)modifyEmailWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//修改密码
-(void)modifyPwdWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//修改昵称
-(void)modifyNickNameWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//修改头像
-(void)modifyIncopathWithInfo:(NSDictionary *)info uccess:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//获取用户信息
-(void)getUserInfoWithInfo:(NSDictionary *)info uccess:(successIdWithBlock)success failure:(failureIdWithBlock)failure;



//绑定第三方账号
-(void)bandThirdPartAccountWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//解绑第三方账号
-(void)unbandThirdPartAccountWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//发送销毁账号验证码
- (void)sendDestroyAccountCodeWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//删除家庭数据
- (void)delAllFamilyWithPrimaryWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;
//删除账号
-(void)deleteAccountWithInfo:(NSDictionary *)info success:(successIdWithBlock)success failure:(failureIdWithBlock)failure;






- (NSString *)p_toJsonString:(NSDictionary *)dic;
- (NSDictionary *)p_toDictory:(id)json;
@end

NS_ASSUME_NONNULL_END
