#import "BlaccountFlutterPlugin.h"
#import "AppSDKManager.h"



@implementation BlaccountFlutterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"blaccount_flutter_plugin"
            binaryMessenger:[registrar messenger]];
  BlaccountFlutterPlugin* instance = [[BlaccountFlutterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if ([@"getPlatformVersion" isEqualToString:call.method]) {
        result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
    }else if ([@"init_blsdk_account" isEqualToString:call.method]) {
        BOOL isSuccess = [[AppSDKManager sharedManager] blAppSDKAccountInit];
        result(@(isSuccess));
    }else if ([@"login" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] loginWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"local_login" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] localLoginWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_fast_login_vcode" isEqualToString:call.method]){
        [[AppSDKManager sharedManager] sendFastVCodeForLoginWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"fast_login" isEqualToString:call.method]){
        [[AppSDKManager sharedManager] fastLoginWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_phone_reg_vcode" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] sendPhoneCodeForRegisterWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_email_reg_vcode" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] sendEmailCodeForRegisterWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"regist" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] registerAccountWithInfo:[[AppSDKManager sharedManager] p_toDictory:[call.arguments objectForKey:@"data"]] success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"reset_password" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] resetPwdWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_reset_pwd_vcode" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] resetPwdSendVCodeWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_modify_phone_vcode" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] sendVCodeToModifyPhoneWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_modify_email_vcode" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] sendVCodeToModifyEmailWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"modify_email" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] modifyEmailWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"modify_phone" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] modifyPhoneWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"modify_password" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] modifyPwdWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"modify_nickname" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] modifyNickNameWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"modify_icon" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] modifyIncopathWithInfo:call.arguments uccess:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"query_users_info" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] getUserInfoWithInfo:call.arguments uccess:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"band_thirdparty" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] bandThirdPartAccountWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"unband_thirdparty" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] unbandThirdPartAccountWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"send_destory_account_code" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] sendDestroyAccountCodeWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"delete_all_familydata" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] delAllFamilyWithPrimaryWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    }else if ([@"delete_account" isEqualToString:call.method]) {
        [[AppSDKManager sharedManager] deleteAccountWithInfo:call.arguments success:^(id  _Nullable param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        } failure:^(id  _Nonnull param) {
            result([[AppSDKManager sharedManager] p_toJsonString:param]);
        }];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

@end
